/*
 * Draws out each pin number
 */



int count, num1, num2, num3, num4, i, j;
char sex;
Pin[] pinNumbers;
PFont font;

class Pin {
  char sex;
  int num1, num2, num3, num4;

  Pin(char s, int n1, int n2, int n3, int n4) {
    sex = s;
    num1 = n1;
    num2 = n2;
    num3 = n3;
    num4 = n4;
  }

  void printPin() {
    println(this.sex + ", " + this.num1 + ", " + this.num2 + ", " + this.num3 + ", " + this.num4);
  }

  int num1(){
    return this.num1;
  }

  int num2(){
    return this.num2;
  }

  int num3(){
    return this.num3;
  }

  int num4(){
    return this.num4;
  }

  char sex() {
    return this.sex;
  }
}

void setup() {
  size(900,450);
  background(255);
  scrape();
  main();
  i = 0;
  j = 3;
  font = createFont("visitor2.ttf", 69);
  textFont(font);
  frameRate(1);
  draw();
}

void scrape() {
  count = 0;

  pinNumbers = new Pin[100];
  String[] data = loadStrings("Information Visualization Survey.tsv");

  for (int i = 1; i < data.length; i++) {
    String[] entry = splitTokens(data[i]);
    if (entry[3].equals("Yes")) {
      if ( entry[2].equals("Male")) {
        sex = 'm';
      }
      else {
        sex = 'f';
      }
      num1 = int(entry[4]);
      num2 = int(entry[5]);
      num3 = int(entry[6]);
      num4 = int(entry[7]);

      pinNumbers[count] = new Pin(sex, num1, num2, num3, num4);
      count++;
    }
  }

  for (int i = 0; i < count; i++) {
    pinNumbers[i].printPin();
  }
  println("count is " + count);

}

void main() {
  background(255);
  stroke(236);
  fill(236);
  strokeWeight(1);
  rect(30,30,60,60);
  rect(120,30,60,60);
  rect(210,30,60,60);
  rect(30,120,60,60);
  rect(120,120,60,60);
  rect(210,120,60,60);
  rect(30,210,60,60);
  rect(120,210,60,60);
  rect(210,210,60,60);
  rect(120,300,60,60);
}

void draw() {
  int one, two, three, four;
  one = pinNumbers[i].num1();
  two = pinNumbers[i].num2();
  three = pinNumbers[i].num3();
  four = pinNumbers[i].num4();

  main();

  if (j == 0) {
    press(one);
  }

  if (j == 1) {
    press(two);
  }

  if (j == 2) {
    press(three);
  }

  if (j == 3) {
    press(four);
  }

  if (j >= 1) {  
    strokeWeight(6);
    stroke(255,3,3);
    noFill();
    beginShape();

    if (one == two) {
      strokeWeight(18);
      point(xCoordinate(one), yCoordinate(one));
      strokeWeight(6);
    }
    else {
      vertex(xCoordinate(one), yCoordinate(one));
      vertex(xCoordinate(two), yCoordinate(two));    
    }
    endShape();
  }
  if (j >= 2) {
    stroke(255,255,3);
    noFill();
    beginShape();
    if (two == three && j == 2) {
      strokeWeight(18);
      point(xCoordinate(two), yCoordinate(two));
      strokeWeight(6);
    }
    else {
      vertex(xCoordinate(two), yCoordinate(two));    
      vertex(xCoordinate(three), yCoordinate(three));    
    }
    endShape();
  }

  if (j >= 3) {
    stroke(23,255,3);
    noFill();
    beginShape();
    if (three == four && j == 3) {
      strokeWeight(18);
      point(xCoordinate(three), yCoordinate(four));
      strokeWeight(6);
    }
    else {
      vertex(xCoordinate(three), yCoordinate(three));    
      vertex(xCoordinate(four), yCoordinate(four));    
    }
    endShape();    
  }

  println(i);
  j++;
  if (j == 4) {
    j = 0;
    i++;
    i = i%count;
  }

  text(pinNumbers[i].sex(), 240, 330);
}

int xCoordinate(int n) {
  if (n == 1 || n == 4 || n == 7) {
    return 60;
  }
  else if (n == 3 || n == 6 || n == 9) {
    return 240;
  }
  else {
    return 150;
  }
}

int yCoordinate(int n) {
  if (n == 1 || n == 2 || n == 3) {
    return 60;
  }
  else if (n == 4 || n == 5 || n == 6) {
    return 150;
  }
  else if (n == 7 || n == 8 || n == 9) {
    return 240;
  }
  else {
    return 330;
  }
}

void press(int n) {

  stroke(255,255,136);
  fill(255,255,136);
  strokeWeight(1);

  if (n == 1) {
    rect(30,30,60,60);  
  }
  if (n == 2) {
    rect(120,30,60,60);
  }
  if (n == 3) {
    rect(210,30,60,60);
  }
  if (n == 4) {
    rect(30,120,60,60);
  }
  if (n == 5) {
    rect(120,120,60,60);
  }
  if (n == 6) {
    rect(210,120,60,60);
  }
  if (n == 7) {
    rect(30,210,60,60);
  }
  if (n == 8) {
    rect(120,210,60,60);
  }
  if (n == 9) {
    rect(210,210,60,60);
  }
  if (n == 0) {
    rect(120,300,60,60);
  }
}















