/*
 * Shows densities for all number
 */



int count, num1, num2, num3, num4, i, j;
char sex;
Pin[] pinNumbers;
Pad firstNum, secondNum, thirdNum, fourthNum, all;
PFont font;

class Pad {
  int[] numbers;

  Pad() {
    numbers = new int[10];
    for (int i = 0; i < 10; i++) {
      numbers[i] = 0;
    }
  }

  void incNum(int n) {
    numbers[n] ++;
  }

  int getNum(int n) {
    return numbers[n];
  }

  String toString() {
    String answer = ": ";
    for (int i = 0; i < 10; i++) {
      answer += numbers[i] + " : ";
    }
    return answer;
  }
}

class Pin {
  char sex;
  int num1, num2, num3, num4;

  Pin(char s, int n1, int n2, int n3, int n4) {
    sex = s;
    num1 = n1;
    num2 = n2;
    num3 = n3;
    num4 = n4;
  }

  void printPin() {
    println(this.sex + ", " + this.num1 + ", " + this.num2 + ", " + this.num3 + ", " + this.num4);
  }

  int num1(){
    return this.num1;
  }

  int num2(){
    return this.num2;
  }

  int num3(){
    return this.num3;
  }

  int num4(){
    return this.num4;
  }

  char sex() {
    return this.sex;
  }
}

void setup() {
  size(960,270);
  background(255);
  scrape();
  main();
  i = 0;
  j = 3;
  font = createFont("visitor2.ttf", 69);
  textFont(font);
  frameRate(1);
  draw();
}

void scrape() {
  count = 0;

  pinNumbers = new Pin[100];

  firstNum = new Pad();
  secondNum = new Pad();
  thirdNum = new Pad();
  fourthNum = new Pad();
  all = new Pad();

  String[] data = loadStrings("Information Visualization Survey.tsv");

  for (int i = 1; i < data.length; i++) {
    String[] entry = splitTokens(data[i]);
    if (entry[3].equals("Yes")) {
      if ( entry[2].equals("Male")) {
        sex = 'm';
      }
      else {
        sex = 'f';
      }
      num1 = int(entry[4]);
      num2 = int(entry[5]);
      num3 = int(entry[6]);
      num4 = int(entry[7]);

      firstNum.incNum(num1);
      secondNum.incNum(num2);
      thirdNum.incNum(num3);
      fourthNum.incNum(num4);

      all.incNum(num1);
      all.incNum(num2);
      all.incNum(num3);
      all.incNum(num4);

      pinNumbers[count] = new Pin(sex, num1, num2, num3, num4);
      count++;
    }
  }

  for (int i = 0; i < count; i++) {
    pinNumbers[i].printPin();
  }
  println("count is " + count);

  for (int i = 0; i < 10; i++) {
    println("firstNum : " + i + " : " + firstNum.getNum(i));
  }

  for (int i = 0; i < 10; i++) {
    println("secondNum : " + i + " : " + secondNum.getNum(i));
  }

  for (int i = 0; i < 10; i++) {
    println("thirdNum : " + i + " : " + thirdNum.getNum(i));
  }

  for (int i = 0; i < 10; i++) {
    println("fourthNum : " + i + " : " + fourthNum.getNum(i));
  }

  for (int i = 0; i < 10; i++) {
    println("all : " + i + " : " + all.getNum(i));
  }

}

void main() {
  background(0);
  strokeWeight(1);

  Pad temp;

  int numSize = 42;
  int ratio = count;
  temp = all;

  stroke(255, 255-min(255, 255 * temp.getNum(1) / ratio), 255-min(510 * temp.getNum(1) / ratio, 255));
  fill(255, 255-min(255, 255 * temp.getNum(1) / ratio), 255-min(510 * temp.getNum(1) / ratio, 255));
  rect( 30, 30, numSize, numSize);
  printC(255, 255-min(255, 255 * temp.getNum(1) / ratio), 255-min(510 * temp.getNum(1) / ratio, 255));

  stroke(255, 255-min(255, 255 * temp.getNum(2) / ratio), 255-min(510 * temp.getNum(2) / ratio, 255));
  fill(255, 255-min(255, 255 * temp.getNum(2) / ratio), 255-min(510 * temp.getNum(2) / ratio, 255));
  rect( 90, 30, numSize, numSize);
  printC(255, 255-min(255, 255 * temp.getNum(2) / ratio), 255-min(510 * temp.getNum(2) / ratio, 255));

  stroke(255, 255-min(255, 255 * temp.getNum(3) / ratio), 255-min(510 * temp.getNum(3) / ratio, 255));
  fill(255, 255-min(255, 255 * temp.getNum(3) / ratio), 255-min(510 * temp.getNum(3) / ratio, 255));
  rect( 150, 30, numSize, numSize);
  printC(255, 255-min(255, 255 * temp.getNum(3) / ratio), 255-min(510 * temp.getNum(3) / ratio, 255));

  stroke(255, 255-min(255, 255 * temp.getNum(4) / ratio), 255-min(510 * temp.getNum(4) / ratio, 255));
  fill(255, 255-min(255, 255 * temp.getNum(4) / ratio), 255-min(510 * temp.getNum(4) / ratio, 255));
  rect( 30, 90, numSize, numSize);
  printC(255, 255-min(255, 255 * temp.getNum(4) / ratio), 255-min(510 * temp.getNum(4) / ratio, 255));

  stroke(255, 255-min(255, 255 * temp.getNum(5) / ratio), 255-min(510 * temp.getNum(5) / ratio, 255));
  fill(255, 255-min(255, 255 * temp.getNum(5) / ratio), 255-min(510 * temp.getNum(5) / ratio, 255));
  rect( 90, 90, numSize, numSize);
  printC(255, 255-min(255, 255 * temp.getNum(5) / ratio), 255-min(510 * temp.getNum(5) / ratio, 255));

  stroke(255, 255-min(255, 255 * temp.getNum(6) / ratio), 255-min(510 * temp.getNum(6) / ratio, 255));
  fill(255, 255-min(255, 255 * temp.getNum(6) / ratio), 255-min(510 * temp.getNum(6) / ratio, 255));   
  rect( 150, 90, numSize, numSize);
  printC(255, 255-min(255, 255 * temp.getNum(6) / ratio), 255-min(510 * temp.getNum(6) / ratio, 255));

  stroke(255, 255-min(255, 255 * temp.getNum(7) / ratio), 255-min(510 * temp.getNum(7) / ratio, 255));
  fill(255, 255-min(255, 255 * temp.getNum(7) / ratio), 255-min(510 * temp.getNum(7) / ratio, 255));
  rect( 30, 150, numSize, numSize);
  printC(255, 255-min(255, 255 * temp.getNum(7) / ratio), 255-min(510 * temp.getNum(7) / ratio, 255));

  stroke(255, 255-min(255, 255 * temp.getNum(8) / ratio), 255-min(510 * temp.getNum(8) / ratio, 255));
  fill(255, 255-min(255, 255 * temp.getNum(8) / ratio), 255-min(510 * temp.getNum(8) / ratio, 255));
  rect( 90, 150, numSize, numSize);
  printC(255, 255-min(255, 255 * temp.getNum(8) / ratio), 255-min(510 * temp.getNum(8) / ratio, 255));

  stroke(255, 255-min(255, 255 * temp.getNum(9) / ratio), 255-min(510 * temp.getNum(9) / ratio, 255));
  fill(255, 255-min(255, 255 * temp.getNum(9) / ratio), 255-min(510 * temp.getNum(9) / ratio, 255));
  rect( 150, 150, numSize, numSize);
  printC(255, 255-min(255, 255 * temp.getNum(9) / ratio), 255-min(510 * temp.getNum(9) / ratio, 255));

  stroke(255, 255-min(255, 255 * temp.getNum(0) / ratio), 255-min(510 * temp.getNum(0) / ratio, 255));
  fill(255, 255-min(255, 255 * temp.getNum(0) / ratio), 255-min(510 * temp.getNum(0) / ratio, 255));
  rect( 90, 210, numSize, numSize);
  printC(255, 255-min(255, 255 * temp.getNum(0) / ratio), 255-min(510 * temp.getNum(0) / ratio, 255));

  ratio = 20;

  for (int i = 0; i < 4; i++) {

    if (i == 0) {
      temp = firstNum;
      println(temp.toString());
    }
    else if (i == 1) {
      temp = secondNum;
      println(temp.toString());
    }
    else if (i == 2) {
      temp = thirdNum;
      println(temp.toString());
    }
    else {
      temp = fourthNum;
      println(temp.toString());
    }

    stroke(255, 255-min(255, 255 * temp.getNum(1) / ratio), 255-min(510 * temp.getNum(1) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(1) / ratio), 255-min(510 * temp.getNum(1) / ratio, 255));
    rect( 30+(i*240) ,  30, numSize, numSize);
    printC(255, 255-min(255, 255 * temp.getNum(1) / ratio), 255-min(510 * temp.getNum(1) / ratio, 255));

    stroke(255, 255-min(255, 255 * temp.getNum(2) / ratio), 255-min(510 * temp.getNum(2) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(2) / ratio), 255-min(510 * temp.getNum(2) / ratio, 255));
    rect( 90+(i*240) ,  30, numSize, numSize);
    printC(255, 255-min(255, 255 * temp.getNum(2) / ratio), 255-min(510 * temp.getNum(2) / ratio, 255));

    stroke(255, 255-min(255, 255 * temp.getNum(3) / ratio), 255-min(510 * temp.getNum(3) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(3) / ratio), 255-min(510 * temp.getNum(3) / ratio, 255));
    rect( 150+(i*240),  30, numSize, numSize);
    printC(255, 255-min(255, 255 * temp.getNum(3) / ratio), 255-min(510 * temp.getNum(3) / ratio, 255));

    stroke(255, 255-min(255, 255 * temp.getNum(4) / ratio), 255-min(510 * temp.getNum(4) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(4) / ratio), 255-min(510 * temp.getNum(4) / ratio, 255));
    rect( 30+(i*240) ,  90, numSize, numSize);
    printC(255, 255-min(255, 255 * temp.getNum(4) / ratio), 255-min(510 * temp.getNum(4) / ratio, 255));

    stroke(255, 255-min(255, 255 * temp.getNum(5) / ratio), 255-min(510 * temp.getNum(5) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(5) / ratio), 255-min(510 * temp.getNum(5) / ratio, 255));
    rect( 90+(i*240) ,  90, numSize, numSize);
    printC(255, 255-min(255, 255 * temp.getNum(5) / ratio), 255-min(510 * temp.getNum(5) / ratio, 255));

    stroke(255, 255-min(255, 255 * temp.getNum(6) / ratio), 255-min(510 * temp.getNum(6) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(6) / ratio), 255-min(510 * temp.getNum(6) / ratio, 255));   
    rect( 150+(i*240),  90, numSize, numSize);
    printC(255, 255-min(255, 255 * temp.getNum(6) / ratio), 255-min(510 * temp.getNum(6) / ratio, 255));

    stroke(255, 255-min(255, 255 * temp.getNum(7) / ratio), 255-min(510 * temp.getNum(7) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(7) / ratio), 255-min(510 * temp.getNum(7) / ratio, 255));
    rect( 30+(i*240) , 150, numSize, numSize);
    printC(255, 255-min(255, 255 * temp.getNum(7) / ratio), 255-min(510 * temp.getNum(7) / ratio, 255));

    stroke(255, 255-min(255, 255 * temp.getNum(8) / ratio), 255-min(510 * temp.getNum(8) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(8) / ratio), 255-min(510 * temp.getNum(8) / ratio, 255));
    rect( 90+(i*240) , 150, numSize, numSize);
    printC(255, 255-min(255, 255 * temp.getNum(8) / ratio), 255-min(510 * temp.getNum(8) / ratio, 255));

    stroke(255, 255-min(255, 255 * temp.getNum(9) / ratio), 255-min(510 * temp.getNum(9) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(9) / ratio), 255-min(510 * temp.getNum(9) / ratio, 255));
    rect( 150+(i*240), 150, numSize, numSize);
    printC(255, 255-min(255, 255 * temp.getNum(9) / ratio), 255-min(510 * temp.getNum(9) / ratio, 255));

    stroke(255, 255-min(255, 255 * temp.getNum(0) / ratio), 255-min(510 * temp.getNum(0) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(0) / ratio), 255-min(510 * temp.getNum(0) / ratio, 255));
    rect( 90+(i*240) , 210, numSize, numSize);
    printC(255, 255-min(255, 255 * temp.getNum(0) / ratio), 255-min(510 * temp.getNum(0) / ratio, 255));
  }

}


void printC(int x, int y, int z) {
  println(x + " : " + y  + " : " + z);
}


























