/*
 * Shows densities for repeated digit patterns
 */



int count, num1, num2, num3, num4, i, j;
char sex;
Pin[] pinNumbers;
Pad firstNum, secondNum, thirdNum, fourthNum, all;
PFont font;

int  pattern12, pattern13, pattern14, pattern23, pattern24, pattern34, patternTriple, patternAll;
int [] p12, p13, p14, p23, p24, p34, tripleNums, allNums;
int iter;

class Pad {
  int[] numbers;

  Pad() {
    numbers = new int[10];
    for (int i = 0; i < 10; i++) {
      numbers[i] = 0;
    }
  }

  void incNum(int n) {
    numbers[n] ++;
  }

  int getNum(int n) {
    return numbers[n];
  }

  String toString() {
    String answer = ": ";
    for (int i = 0; i < 10; i++) {
      answer += numbers[i] + " : ";
    }
    return answer;
  }
}

class Pin {
  char sex;
  int num1, num2, num3, num4;

  Pin(char s, int n1, int n2, int n3, int n4) {
    sex = s;
    num1 = n1;
    num2 = n2;
    num3 = n3;
    num4 = n4;
  }

  void printPin() {
    println(this.sex + ", " + this.num1 + ", " + this.num2 + ", " + this.num3 + ", " + this.num4);
  }

  boolean threeMatching() {
    if (num1 == num2) {
      if (num1 == num3 || num1 == num4) {
        return true;
      }
      else {
        return false;
      }
    }
    else if (num3 == num4) {
      if (num3 == num1 || num3 == num2) {
        return true;
      }
      else {
        return false;
      }
    }
    else {
      return false;
    }
  }

  int num1(){
    return this.num1;
  }

  int num2(){
    return this.num2;
  }

  int num3(){
    return this.num3;
  }

  int num4(){
    return this.num4;
  }

  char sex() {
    return this.sex;
  }
}

void setup() {
  size(960,270);
  background(255);
  scrape();
  repeatPatterns();
  iter = 7;
  font = createFont("visitor2.ttf", 120);
  textFont(font);
  frameRate(1);
  draw();
}

void scrape() {
  count = 0;

  pinNumbers = new Pin[100];

  firstNum = new Pad();
  secondNum = new Pad();
  thirdNum = new Pad();
  fourthNum = new Pad();
  all = new Pad();

  String[] data = loadStrings("Information Visualization Survey.tsv");

  for (int i = 1; i < data.length; i++) {
    String[] entry = splitTokens(data[i]);
    if (entry[3].equals("Yes")) {
      if ( entry[2].equals("Male")) {
        sex = 'm';
      }
      else {
        sex = 'f';
      }
      num1 = int(entry[4]);
      num2 = int(entry[5]);
      num3 = int(entry[6]);
      num4 = int(entry[7]);

      firstNum.incNum(num1);
      secondNum.incNum(num2);
      thirdNum.incNum(num3);
      fourthNum.incNum(num4);

      all.incNum(num1);
      all.incNum(num2);
      all.incNum(num3);
      all.incNum(num4);

      pinNumbers[count] = new Pin(sex, num1, num2, num3, num4);
      count++;
    }
  }

  for (int i = 0; i < count; i++) {
    pinNumbers[i].printPin();
  }
  println("count is " + count);

  for (int i = 0; i < 10; i++) {
    println("firstNum : " + i + " : " + firstNum.getNum(i));
  }

  for (int i = 0; i < 10; i++) {
    println("secondNum : " + i + " : " + secondNum.getNum(i));
  }

  for (int i = 0; i < 10; i++) {
    println("thirdNum : " + i + " : " + thirdNum.getNum(i));
  }

  for (int i = 0; i < 10; i++) {
    println("fourthNum : " + i + " : " + fourthNum.getNum(i));
  }

  for (int i = 0; i < 10; i++) {
    println("all : " + i + " : " + all.getNum(i));
  }

}

void draw() {
  background(0);
  strokeWeight(1);

  stroke(255);
  fill(255);

  int numSize = 42;
  int ratio = 4;

  for (int i = 0; i < 4; i++) {
    rect( 30+(i*240) ,  30, numSize, numSize);
    rect( 90+(i*240) ,  30, numSize, numSize);
    rect( 150+(i*240),  30, numSize, numSize);
    rect( 30+(i*240) ,  90, numSize, numSize);
    rect( 90+(i*240) ,  90, numSize, numSize);
    rect( 150+(i*240),  90, numSize, numSize);
    rect( 30+(i*240) , 150, numSize, numSize);
    rect( 90+(i*240) , 150, numSize, numSize);
    rect( 150+(i*240), 150, numSize, numSize);
    rect( 90+(i*240) , 210, numSize, numSize);
  }

  int[] temp;

  if (iter == 0) {
    temp = p12;
    text("1 : 2", 960, 90);
    text(pattern12, 960, 180);
    colorPad(temp,1,2);
  }
  else if (iter == 1) {
    temp = p13; 
    text("1 : 3", 960, 90);
    text(pattern13, 960, 180);
    colorPad(temp,1,3);
  }
  else if (iter == 2) {
    temp = p14;
    text("1 : 4", 960, 90);
    text(pattern14, 960, 180);
    colorPad(temp,1,4);
  }
  else if (iter == 3) {
    temp = p23;
    text("2 : 3", 960, 90);
    text(pattern23, 960, 180);
    colorPad(temp,2,3);
  }
  else if (iter == 4) {
    temp = p24;
    text("2 : 4", 960, 90);
    text(pattern24, 960, 180);
    colorPad(temp,2,4);
  }
  else if (iter == 5) {
    temp = p34;
    text("3 : 4", 960, 90);
    text(pattern34, 960, 180);
    colorPad(temp,3,4);
  }
  else if (iter == 6) {
    temp = tripleNums;
    text("TRIPLE", 960, 90);
    text(patternTriple, 960, 180);

    for (int i = 0; i < 4; i++){
      if (i != 3) {
        stroke(255, 255-min(255, 255 * temp[1] / ratio), 255-min(510 * temp[1] / ratio, 255));
        fill(255, 255-min(255, 255 * temp[1] / ratio), 255-min(510 * temp[1] / ratio, 255));
        rect( 30+(i*240) ,  30, numSize, numSize);
      }
      if (i != 2) {
        stroke(255, 255-min(255, 255 * temp[5] / ratio), 255-min(510 * temp[5] / ratio, 255));
        fill(255, 255-min(255, 255 * temp[5] / ratio), 255-min(510 * temp[5] / ratio, 255));
        rect( 90+(i*240) ,  90, numSize, numSize);
      }
    }
  }
  else {
    temp = allNums;
    text("ALL", 960, 90);  
    text(patternAll, 960, 180);
  }

  iter ++;
  iter = iter % 8;
  stroke(255);
}


void colorPad(int[] temp, int m, int n) {

  int numSize = 42;
  int ratio = 4;

  for (int i = (m-1); i < n; i+=(n-m)) {

    stroke(255, 255-min(255, 255 * temp[1] / ratio), 255-min(510 * temp[1] / ratio, 255));
    fill(255, 255-min(255, 255 * temp[1] / ratio), 255-min(510 * temp[1] / ratio, 255));
    rect( 30+(i*240) ,  30, numSize, numSize);
    //printC(255, 255-min(255, 255 * temp[1] / ratio), 255-min(510 * temp[1] / ratio, 255));

    stroke(255, 255-min(255, 255 * temp[2] / ratio), 255-min(510 * temp[2] / ratio, 255));
    fill(255, 255-min(255, 255 * temp[2] / ratio), 255-min(510 * temp[2] / ratio, 255));
    rect( 90+(i*240) ,  30, numSize, numSize);
    //printC(255, 255-min(255, 255 * temp[2] / ratio), 255-min(510 * temp[2] / ratio, 255));

    stroke(255, 255-min(255, 255 * temp[3] / ratio), 255-min(510 * temp[3] / ratio, 255));
    fill(255, 255-min(255, 255 * temp[3] / ratio), 255-min(510 * temp[3] / ratio, 255));
    rect( 150+(i*240),  30, numSize, numSize);
    //printC(255, 255-min(255, 255 * temp[3] / ratio), 255-min(510 * temp[3] / ratio, 255));

    stroke(255, 255-min(255, 255 * temp[4] / ratio), 255-min(510 * temp[4] / ratio, 255));
    fill(255, 255-min(255, 255 * temp[4] / ratio), 255-min(510 * temp[4] / ratio, 255));
    rect( 30+(i*240) ,  90, numSize, numSize);
    //printC(255, 255-min(255, 255 * temp[4] / ratio), 255-min(510 * temp[4] / ratio, 255));

    stroke(255, 255-min(255, 255 * temp[5] / ratio), 255-min(510 * temp[5] / ratio, 255));
    fill(255, 255-min(255, 255 * temp[5] / ratio), 255-min(510 * temp[5] / ratio, 255));
    rect( 90+(i*240) ,  90, numSize, numSize);
    //printC(255, 255-min(255, 255 * temp[5] / ratio), 255-min(510 * temp[5] / ratio, 255));

    stroke(255, 255-min(255, 255 * temp[6] / ratio), 255-min(510 * temp[6] / ratio, 255));
    fill(255, 255-min(255, 255 * temp[6] / ratio), 255-min(510 * temp[6] / ratio, 255));   
    rect( 150+(i*240),  90, numSize, numSize);
    //printC(255, 255-min(255, 255 * temp[6] / ratio), 255-min(510 * temp[6] / ratio, 255));

    stroke(255, 255-min(255, 255 * temp[7] / ratio), 255-min(510 * temp[7] / ratio, 255));
    fill(255, 255-min(255, 255 * temp[7] / ratio), 255-min(510 * temp[7] / ratio, 255));
    rect( 30+(i*240) , 150, numSize, numSize);
    //printC(255, 255-min(255, 255 * temp[7] / ratio), 255-min(510 * temp[7] / ratio, 255));

    stroke(255, 255-min(255, 255 * temp[8] / ratio), 255-min(510 * temp[8] / ratio, 255));
    fill(255, 255-min(255, 255 * temp[8] / ratio), 255-min(510 * temp[8] / ratio, 255));
    rect( 90+(i*240) , 150, numSize, numSize);
    //printC(255, 255-min(255, 255 * temp[8] / ratio), 255-min(510 * temp[8] / ratio, 255));

    stroke(255, 255-min(255, 255 * temp[9] / ratio), 255-min(510 * temp[9] / ratio, 255));
    fill(255, 255-min(255, 255 * temp[9] / ratio), 255-min(510 * temp[9] / ratio, 255));
    rect( 150+(i*240), 150, numSize, numSize);
    //printC(255, 255-min(255, 255 * temp[9] / ratio), 255-min(510 * temp[9] / ratio, 255));

    stroke(255, 255-min(255, 255 * temp[0] / ratio), 255-min(510 * temp[0] / ratio, 255));
    fill(255, 255-min(255, 255 * temp[0] / ratio), 255-min(510 * temp[0] / ratio, 255));
    rect( 90+(i*240) , 210, numSize, numSize);
    //printC(255, 255-min(255, 255 * temp[0] / ratio), 255-min(510 * temp[0] / ratio, 255));
  }

}




void printC(int x, int y, int z) {
  println(x + " : " + y  + " : " + z);
}

void repeatPatterns() {

  pattern12 = 0;
  pattern13 = 0;
  pattern14 = 0;
  pattern23 = 0;
  pattern24 = 0;
  pattern34 = 0;
  patternTriple = 0;
  patternAll = 0;

  p12 = new int[10];
  p13 = new int[10];
  p14 = new int[10];
  p23 = new int[10];
  p24 = new int[10];
  p34 = new int[10];
  tripleNums = new int[10];
  allNums = new int[10];

  for (int i = 0; i < count; i++) {
    if (pinNumbers[i].num1() == pinNumbers[i].num2()) {
      if (!pinNumbers[i].threeMatching()) {     
        pattern12++;
        p12[pinNumbers[i].num1()]++;
      }
    }
  }
  for (int i = 0; i < count; i++) {
    if (pinNumbers[i].num1() == pinNumbers[i].num3()) {
      if (!pinNumbers[i].threeMatching()) {      
        pattern13++;
        p13[pinNumbers[i].num1()]++;
      }
    }
  }
  for (int i = 0; i < count; i++) {
    if (pinNumbers[i].num1() == pinNumbers[i].num4()) {
      if (!pinNumbers[i].threeMatching()) {      
        pattern14++;
        p14[pinNumbers[i].num1()]++;
      }
    }
  }
  for (int i = 0; i < count; i++) {
    if (pinNumbers[i].num2() == pinNumbers[i].num3()) {
      if (!pinNumbers[i].threeMatching()) {      
        pattern23++;
        p23[pinNumbers[i].num2()]++;
      }
    }
  }
  for (int i = 0; i < count; i++) {
    if (pinNumbers[i].num2() == pinNumbers[i].num4()) {
      if (!pinNumbers[i].threeMatching()) {      
        pattern24++;
        p24[pinNumbers[i].num2()]++;
      }
    }
  }
  for (int i = 0; i < count; i++) {
    if (pinNumbers[i].num3() == pinNumbers[i].num4()) {
      if (!pinNumbers[i].threeMatching()) {
        pattern34++;
        p34[pinNumbers[i].num3()]++;
      }
    }
  }
  for (int i = 0; i < count; i++) {
    if (pinNumbers[i].threeMatching()) {
      patternTriple++;
      if (pinNumbers[i].num1() == pinNumbers[i].num2()) {
        tripleNums[pinNumbers[i].num1()]++;
      }
      else {
        tripleNums[pinNumbers[i].num3()]++;
      }
    }
  }
  for (int i = 0; i < count; i++) {
    if (pinNumbers[i].num1() == pinNumbers[i].num2()) {
      if (pinNumbers[i].num2() == pinNumbers[i].num3()) {
        if (pinNumbers[i].num3() == pinNumbers[i].num4()) {
          patternAll++;
          allNums[pinNumbers[i].num1()]++;
        }
      }
    }
  }

  println("Number of repeats from 1 to 2 --> " + pattern12);
  println("Number of repeats from 1 to 3 --> " + pattern13);
  println("Number of repeats from 1 to 4 --> " + pattern14);
  println("Number of repeats from 2 to 3 --> " + pattern23);
  println("Number of repeats from 2 to 4 --> " + pattern24);
  println("Number of repeats from 3 to 4 --> " + pattern34);
  println("Number of triplets --> " + patternTriple);  
  println("Number of completely one number --> " + patternAll);

  println();
  println(p12);

  println();
  println(p13);

  println();
  println(p14);

  println();
  println(p23);

  println();
  println(p24);

  println();
  println(p34);

  println();
  println(tripleNums);

  println();
  println(allNums);
}
