/*
 * Beginning of an interactive piece for mapping between digits
 */



char sexFilter;
int count, currentCount;
Pin[] pinNumbers, currentSet;
Pad firstNum, secondNum, thirdNum, fourthNum;
int pin1, pin2, pin3, pin4;
PFont font;

class Pad {
  int[] numbers;

  Pad() {
    numbers = new int[10];
    for (int i = 0; i < 10; i++) {
      numbers[i] = 0;
    }
  }

  void incNum(int n) {
    numbers[n] ++;
  }

  int getNum(int n) {
    return numbers[n];
  }

  String toString() {
    String answer = ": ";
    for (int i = 0; i < 10; i++) {
      answer += numbers[i] + " : ";
    }
    return answer;
  }

  int getMax() {
    int answer = 0;
    for (int i = 0; i < 10; i++){
      answer = max(answer, numbers[i]);
    }
    return answer;
  }
}

class Pin {
  char sex;
  int num1, num2, num3, num4;

  Pin(char s, int n1, int n2, int n3, int n4) {
    sex = s;
    num1 = n1;
    num2 = n2;
    num3 = n3;
    num4 = n4;
  }

  void printPin() {
    println(this.sex + ", " + this.num1 + ", " + this.num2 + ", " + this.num3 + ", " + this.num4);
  }

  int num1(){
    return this.num1;
  }

  int num2(){
    return this.num2;
  }

  int num3(){
    return this.num3;
  }

  int num4(){
    return this.num4;
  }

  char sex() {
    return this.sex;
  }

}


















void setup() {
  size(960,270);
  background(255);
  pin1 = -1;
  pin2 = -1;
  pin3 = -1;
  pin4 = -1;

  scrape();
  font = createFont("visitor2.ttf", 120);
  textFont(font);
  frameRate(1);
  main();
}

void scrape() {
  count = 0;
  int num1, num2, num3, num4;
  char sex;

  pinNumbers = new Pin[100];

  firstNum = new Pad();
  secondNum = new Pad();
  thirdNum = new Pad();
  fourthNum = new Pad();

  String[] data = loadStrings("Information Visualization Survey.tsv");

  for (int i = 1; i < data.length; i++) {
    String[] entry = splitTokens(data[i]);
    if (entry[3].equals("Yes")) {
      if ( entry[2].equals("Male")) {
        sex = 'm';
      }
      else {
        sex = 'f';
      }
      num1 = int(entry[4]);
      num2 = int(entry[5]);
      num3 = int(entry[6]);
      num4 = int(entry[7]);

      firstNum.incNum(num1);
      secondNum.incNum(num2);
      thirdNum.incNum(num3);
      fourthNum.incNum(num4);

      pinNumbers[count] = new Pin(sex, num1, num2, num3, num4);
      count++;
    }
  }


  for (int i = 0; i < count; i++) {
    pinNumbers[i].printPin();
  }

  println("count is " + count);

  for (int i = 0; i < 10; i++) {
    println("firstNum : " + i + " : " + firstNum.getNum(i));
  }

  for (int i = 0; i < 10; i++) {
    println("secondNum : " + i + " : " + secondNum.getNum(i));
  }

  for (int i = 0; i < 10; i++) {
    println("thirdNum : " + i + " : " + thirdNum.getNum(i));
  }

  for (int i = 0; i < 10; i++) {
    println("fourthNum : " + i + " : " + fourthNum.getNum(i));
  }

}

void main() {
  
  background(0);
  strokeWeight(1);

  stroke(255);
  fill(255);

  int numSize = 42;
  int ratio = 4;

  for (int i = 0; i < 4; i++) {
    rect( 30+(i*240) ,  30, numSize, numSize);
    rect( 90+(i*240) ,  30, numSize, numSize);
    rect( 150+(i*240),  30, numSize, numSize);
    rect( 30+(i*240) ,  90, numSize, numSize);
    rect( 90+(i*240) ,  90, numSize, numSize);
    rect( 150+(i*240),  90, numSize, numSize);
    rect( 30+(i*240) , 150, numSize, numSize);
    rect( 90+(i*240) , 150, numSize, numSize);
    rect( 150+(i*240), 150, numSize, numSize);
    rect( 90+(i*240) , 210, numSize, numSize);
  }


  buttons();
  pin1 = -1;
  pin2 = -1;
  pin3 = -1;
  pin4 = -1;
 
  sexFilter = 'b';
  updateKeypad();
  colorBackground(0);
  drawConnection();
  println("count = " + count);
  println("currentCount = " + currentCount);
  
  pin1 = 1;

  sexFilter = 'b';
  updateKeypad();
  colorBackground(1);
  drawConnection();
  println("count = " + count);
  println("currentCount = " + currentCount);
    
  pin2 = 8;

  sexFilter = 'b';
  updateKeypad();
  colorBackground(2);
  drawConnection();
  println("count = " + count);
  println("currentCount = " + currentCount);
  
  pin3 = 3;

  sexFilter = 'b';
  updateKeypad();
  colorBackground(3);
  drawConnection();
  println("count = " + count);
  println("currentCount = " + currentCount);
}




void buttons() {


}














void updateKeypad() {
  currentSet = new Pin[100];
  currentCount = 0;
  for (int i = 0; i < count; i++) {

    if ((pinNumbers[i].sex() == sexFilter) || (sexFilter == 'b')) {

      if (pin4 >= 0) {
        if ((pinNumbers[i].num4() == pin4) && (pinNumbers[i].num3() == pin3) && 
          (pinNumbers[i].num2() == pin2) && (pinNumbers[i].num1() == pin1)) {
          currentSet[currentCount] = pinNumbers[i];
          currentCount++;
        }
      }
      else if (pin3 >= 0) {
        if ((pinNumbers[i].num3() == pin3) && (pinNumbers[i].num2() == pin2) && 
          (pinNumbers[i].num1() == pin1)) {
          currentSet[currentCount] = pinNumbers[i];
          currentCount++;
        }
      }
      else if (pin2 >= 0) {
        if ((pinNumbers[i].num2() == pin2) && (pinNumbers[i].num1() == pin1)) {
          currentSet[currentCount] = pinNumbers[i];
          currentCount++;
        }
      }
      else if (pin1 >= 0) {
        if (pinNumbers[i].num1() == pin1) {
          currentSet[currentCount] = pinNumbers[i];
          currentCount++;
        }
      }
      else {
        currentSet[currentCount] = pinNumbers[i];
        currentCount++;
      }
    }
  }
  updatePads();
}

void updatePads() {

  firstNum = new Pad();
  secondNum = new Pad();
  thirdNum = new Pad();
  fourthNum = new Pad();

  for (int i = 0; i < currentCount; i++) {
    firstNum.incNum(currentSet[i].num1());
    secondNum.incNum(currentSet[i].num2());
    thirdNum.incNum(currentSet[i].num3());
    fourthNum.incNum(currentSet[i].num4()); 
  }

}















void colorBackground(int n) {
  strokeWeight(1);

  Pad temp;
  int numSize = 42;
  int currentMax = max(max(firstNum.getMax(), secondNum.getMax()), max(thirdNum.getMax(), fourthNum.getMax()));
  int ratio = (currentMax * 5) / 4;
  if (ratio == 0) {
  ratio++;
  }
  println("max was " + currentMax);
  println("ratio = " + ratio);

  for (int i = n; i < 4; i++) {

    if (i == 0) {
      temp = firstNum;
      println(temp.toString());
    }
    else if (i == 1) {
      temp = secondNum;
      println(temp.toString());
    }
    else if (i == 2) {
      temp = thirdNum;
      println(temp.toString());
    }
    else {
      temp = fourthNum;
      println(temp.toString());
    }

    stroke(255, 255-min(255, 255 * temp.getNum(1) / ratio), 255-min(510 * temp.getNum(1) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(1) / ratio), 255-min(510 * temp.getNum(1) / ratio, 255));
    rect( 30+(i*240) ,  30, numSize, numSize);

    stroke(255, 255-min(255, 255 * temp.getNum(2) / ratio), 255-min(510 * temp.getNum(2) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(2) / ratio), 255-min(510 * temp.getNum(2) / ratio, 255));
    rect( 90+(i*240) ,  30, numSize, numSize);

    stroke(255, 255-min(255, 255 * temp.getNum(3) / ratio), 255-min(510 * temp.getNum(3) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(3) / ratio), 255-min(510 * temp.getNum(3) / ratio, 255));
    rect( 150+(i*240),  30, numSize, numSize);

    stroke(255, 255-min(255, 255 * temp.getNum(4) / ratio), 255-min(510 * temp.getNum(4) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(4) / ratio), 255-min(510 * temp.getNum(4) / ratio, 255));
    rect( 30+(i*240) ,  90, numSize, numSize);

    stroke(255, 255-min(255, 255 * temp.getNum(5) / ratio), 255-min(510 * temp.getNum(5) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(5) / ratio), 255-min(510 * temp.getNum(5) / ratio, 255));
    rect( 90+(i*240) ,  90, numSize, numSize);

    stroke(255, 255-min(255, 255 * temp.getNum(6) / ratio), 255-min(510 * temp.getNum(6) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(6) / ratio), 255-min(510 * temp.getNum(6) / ratio, 255));   
    rect( 150+(i*240),  90, numSize, numSize);

    stroke(255, 255-min(255, 255 * temp.getNum(7) / ratio), 255-min(510 * temp.getNum(7) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(7) / ratio), 255-min(510 * temp.getNum(7) / ratio, 255));
    rect( 30+(i*240) , 150, numSize, numSize);

    stroke(255, 255-min(255, 255 * temp.getNum(8) / ratio), 255-min(510 * temp.getNum(8) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(8) / ratio), 255-min(510 * temp.getNum(8) / ratio, 255));
    rect( 90+(i*240) , 150, numSize, numSize);

    stroke(255, 255-min(255, 255 * temp.getNum(9) / ratio), 255-min(510 * temp.getNum(9) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(9) / ratio), 255-min(510 * temp.getNum(9) / ratio, 255));
    rect( 150+(i*240), 150, numSize, numSize);

    stroke(255, 255-min(255, 255 * temp.getNum(0) / ratio), 255-min(510 * temp.getNum(0) / ratio, 255));
    fill(255, 255-min(255, 255 * temp.getNum(0) / ratio), 255-min(510 * temp.getNum(0) / ratio, 255));
    rect( 90+(i*240) , 210, numSize, numSize);
  }

}

















boolean drawConnection() {

  strokeWeight(3);

  if (pin1 < 0) {
    return false;
  }
  else {
    press(pin1,0);
  }

  if (pin2 < 0) {
    return false;
  }
  else {
    press(pin2,1);
    stroke(255,0,0);
    line(xCoordinate(pin1, 1), yCoordinate(pin1), xCoordinate(pin2, 1), yCoordinate(pin2));
  }

  if (pin3 < 0) {
    return false;
  }
  else {
    press(pin3,2);
    stroke(255,150,150); 
    line(xCoordinate(pin1, 2), yCoordinate(pin1), xCoordinate(pin2, 2), yCoordinate(pin2));
    stroke(255,0,0);   
    line(xCoordinate(pin2, 2), yCoordinate(pin2), xCoordinate(pin3, 2), yCoordinate(pin3));
  }

  if (pin4 < 0) {
    return false;
  }
  else {
    press(pin4,3);
    stroke(255, 236,236);
    line(xCoordinate(pin1, 3), yCoordinate(pin1), xCoordinate(pin2, 3), yCoordinate(pin2));
    stroke(255,150,150); 
    line(xCoordinate(pin2, 3), yCoordinate(pin2), xCoordinate(pin3, 3), yCoordinate(pin3));
    stroke(255,0,0);
    line(xCoordinate(pin3, 3), yCoordinate(pin3), xCoordinate(pin4, 3), yCoordinate(pin4));
  }

  return true;
}

int xCoordinate(int n, int pad) {
  if (n == 1 || n == 4 || n == 7) {
    return 50 + (pad * 240);
  }
  else if (n == 3 || n == 6 || n == 9) {
    return 170 + (pad * 240);
  }
  else {
    return 110 + (pad * 240);
  }
}

int yCoordinate(int n) {
  if (n == 1 || n == 2 || n == 3) {
    return 50;
  }
  else if (n == 4 || n == 5 || n == 6) {
    return 110;
  }
  else if (n == 7 || n == 8 || n == 9) {
    return 170;
  }
  else {
    return 230;
  }
}

void press(int n, int p) {

  stroke(0,255,0);
  noFill();

  if (n == 1) {
    rect(30+(p*240),30,42,42);  
  }
  if (n == 2) {
    rect(90+(p*240),30,42,42);  
  }
  if (n == 3) {
    rect(150+(p*240),30,42,42);  
  }
  if (n == 4) {
    rect(30+(p*240),90,42,42);  
  }
  if (n == 5) {
    rect(90+(p*240),90,42,42);  
  }
  if (n == 6) {
    rect(150+(p*240),90,42,42);  
  }
  if (n == 7) {
    rect(30+(p*240),150,42,42);  
  }
  if (n == 8) {
    rect(90+(p*240),150,42,42);  
  }
  if (n == 9) {
    rect(150+(p*240),150,42,42);  
  }
  if (n == 0) {
    rect(90+(p*240),210,42,42);  
  }
}









